明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1153|回复: 2

这段填充图案的代码错在那里了?

[复制链接]
发表于 2008-5-9 18:38:00 | 显示全部楼层 |阅读模式

Sub test()
    Dim hatchObj As AcadHatch
    Dim patternName As String
    Dim PatternType As Long
    Dim bAssociativity As Boolean
    Dim outerLoop(0 To 0) As AcadEntity
    ' 定义图案填充
    patternName = "ANSI31"
    PatternType = 0
    bAssociativity = True

    ' 当前图纸的实体数目
    Dim n As Long
    n = ThisDrawing.ModelSpace.Count
   
    ' 调用BOUNDARY命令获取某一点处的边界
    Dim Pt As Variant
    Pt = ThisDrawing.Utility.GetPoint(, "指定内部点: ")
    ThisDrawing.SendCommand "_-Boundary" & vbCr & Pt(0) & "," & Pt(1) & vbCr & vbCr
   
    ' 如果存在边界,则会生成新的实体
    If ThisDrawing.ModelSpace.Count > n Then
        Set outerLoop(0) = ThisDrawing.ModelSpace.Item(ThisDrawing.ModelSpace.Count - 1)
    Else
        MsgBox "未发现有效的边界。"
       
    End If
hatchObj.AppendOuterLoop (outerLoop)'这里  运行时错误‘91’ 对象变量或with块变量未设置
    ' 计算并显示图案填充
    hatchObj.Evaluate
    ThisDrawing.Regen True
End Sub

发表于 2008-5-11 19:54:00 | 显示全部楼层

Sub test()
    Dim hatchObj As AcadHatch
    Dim patternName As String
    Dim PatternType As Long
    Dim bAssociativity As Boolean
    Dim outerLoop(0) As AcadEntity
    ' 定义图案填充
    patternName = "ANSI31"
    PatternType = 0
    bAssociativity = True
Set hatchObj = ThisDrawing.ModelSpace. _
        AddHatch(PatternType, patternName, bAssociativity)

    ' 当前图纸的实体数目
    Dim n As Long
    n = ThisDrawing.ModelSpace.count
   
    ' 调用BOUNDARY命令获取某一点处的边界
    Dim Pt As Variant
    Pt = ThisDrawing.Utility.GetPoint(, "指定内部点: ")
    ThisDrawing.SendCommand "_-Boundary" & vbCr & Pt(0) & "," & Pt(1) & vbCr & vbCr
   
    ' 如果存在边界,则会生成新的实体
    If ThisDrawing.ModelSpace.count > n Then
        Set outerLoop(0) = ThisDrawing.ModelSpace.Item(ThisDrawing.ModelSpace.count - 1)
    Else
        MsgBox "未发现有效的边界。"
       
    End If
hatchObj.AppendOuterLoop outerLoop '这里  运行时错误‘91’ 对象变量或with块变量未设置
    ' 计算并显示图案填充
    hatchObj.Evaluate
    ThisDrawing.Regen True
End Sub

改了几处,程序运行正常。

 楼主| 发表于 2008-5-14 15:05:00 | 显示全部楼层
非常感谢chtd!我QQ:22742129交个朋友吧!
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-26 09:46 , Processed in 0.254925 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表